diff --git a/config/arm/arm32_armv8_linux_gcc b/config/arm/arm32_armv8_linux_gcc
index 269a60ba19..af1c8b68c3 100644
--- a/config/arm/arm32_armv8_linux_gcc
+++ b/config/arm/arm32_armv8_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch32'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_armada_linux_gcc b/config/arm/arm64_armada_linux_gcc
index 635b4946a3..7f9090bb44 100644
--- a/config/arm/arm64_armada_linux_gcc
+++ b/config/arm/arm64_armada_linux_gcc
@@ -10,7 +10,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_armv8_linux_clang_ubuntu b/config/arm/arm64_armv8_linux_clang_ubuntu
index 86ae43937b..3d52a5e32e 100644
--- a/config/arm/arm64_armv8_linux_clang_ubuntu
+++ b/config/arm/arm64_armv8_linux_clang_ubuntu
@@ -10,7 +10,7 @@ pkgconfig = 'aarch64-linux-gnu-pkg-config'
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_armv8_linux_gcc b/config/arm/arm64_armv8_linux_gcc
index 529694b49d..98efa7fd2d 100644
--- a/config/arm/arm64_armv8_linux_gcc
+++ b/config/arm/arm64_armv8_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_bluefield_linux_gcc b/config/arm/arm64_bluefield_linux_gcc
index 1286227915..d38922fea5 100644
--- a/config/arm/arm64_bluefield_linux_gcc
+++ b/config/arm/arm64_bluefield_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_centriq2400_linux_gcc b/config/arm/arm64_centriq2400_linux_gcc
index bc8737e072..ad08b2b83c 100644
--- a/config/arm/arm64_centriq2400_linux_gcc
+++ b/config/arm/arm64_centriq2400_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_cn10k_linux_gcc b/config/arm/arm64_cn10k_linux_gcc
index 05d2d64cf2..1a7debfdc4 100644
--- a/config/arm/arm64_cn10k_linux_gcc
+++ b/config/arm/arm64_cn10k_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8.6-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_cn9k_linux_gcc b/config/arm/arm64_cn9k_linux_gcc
index 7416454de0..6f3d933738 100644
--- a/config/arm/arm64_cn9k_linux_gcc
+++ b/config/arm/arm64_cn9k_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_dpaa_linux_gcc b/config/arm/arm64_dpaa_linux_gcc
index 8465b5097b..e60edbaafb 100644
--- a/config/arm/arm64_dpaa_linux_gcc
+++ b/config/arm/arm64_dpaa_linux_gcc
@@ -10,7 +10,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_emag_linux_gcc b/config/arm/arm64_emag_linux_gcc
index 248169ed68..10e2e83b56 100644
--- a/config/arm/arm64_emag_linux_gcc
+++ b/config/arm/arm64_emag_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_ft2000plus_linux_gcc b/config/arm/arm64_ft2000plus_linux_gcc
index ae9f779056..8d65d18b8d 100644
--- a/config/arm/arm64_ft2000plus_linux_gcc
+++ b/config/arm/arm64_ft2000plus_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_graviton2_linux_gcc b/config/arm/arm64_graviton2_linux_gcc
index fdb298bb11..adc96598e0 100644
--- a/config/arm/arm64_graviton2_linux_gcc
+++ b/config/arm/arm64_graviton2_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_graviton3_linux_gcc b/config/arm/arm64_graviton3_linux_gcc
index 19b422075d..805566ae85 100644
--- a/config/arm/arm64_graviton3_linux_gcc
+++ b/config/arm/arm64_graviton3_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_kunpeng920_linux_gcc b/config/arm/arm64_kunpeng920_linux_gcc
index 193fb48a61..ea0f3f96d6 100644
--- a/config/arm/arm64_kunpeng920_linux_gcc
+++ b/config/arm/arm64_kunpeng920_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_kunpeng930_linux_gcc b/config/arm/arm64_kunpeng930_linux_gcc
index e4281ceb4f..3a928ee998 100644
--- a/config/arm/arm64_kunpeng930_linux_gcc
+++ b/config/arm/arm64_kunpeng930_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_n1sdp_linux_gcc b/config/arm/arm64_n1sdp_linux_gcc
index 2806a4241b..6eef27291a 100644
--- a/config/arm/arm64_n1sdp_linux_gcc
+++ b/config/arm/arm64_n1sdp_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_n2_linux_gcc b/config/arm/arm64_n2_linux_gcc
index 7404bd197b..111ae52c5f 100644
--- a/config/arm/arm64_n2_linux_gcc
+++ b/config/arm/arm64_n2_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_stingray_linux_gcc b/config/arm/arm64_stingray_linux_gcc
index 08148b5c3d..41903aaa1f 100644
--- a/config/arm/arm64_stingray_linux_gcc
+++ b/config/arm/arm64_stingray_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_thunderx2_linux_gcc b/config/arm/arm64_thunderx2_linux_gcc
index 32ae938e95..eb07a59da0 100644
--- a/config/arm/arm64_thunderx2_linux_gcc
+++ b/config/arm/arm64_thunderx2_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_thunderxt83_linux_gcc b/config/arm/arm64_thunderxt83_linux_gcc
index e9d9e62d44..cd4f9c2acb 100644
--- a/config/arm/arm64_thunderxt83_linux_gcc
+++ b/config/arm/arm64_thunderxt83_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_thunderxt88_linux_gcc b/config/arm/arm64_thunderxt88_linux_gcc
index c6e5a5656a..b9e0d554a4 100644
--- a/config/arm/arm64_thunderxt88_linux_gcc
+++ b/config/arm/arm64_thunderxt88_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]
diff --git a/config/arm/arm64_tys2500_linux_gcc b/config/arm/arm64_tys2500_linux_gcc
index fce85fb0d8..994803d363 100644
--- a/config/arm/arm64_tys2500_linux_gcc
+++ b/config/arm/arm64_tys2500_linux_gcc
@@ -9,7 +9,7 @@ pcap-config = ''
 [host_machine]
 system = 'linux'
 cpu_family = 'aarch64'
-cpu = 'armv8-a'
+cpu = 'auto'
 endian = 'little'
 
 [properties]